%{!?_httpd_apxs: %{expand: %%global _httpd_apxs %%{_sbindir}/apxs}}
%{!?_httpd_mmn: %{expand: %%global _httpd_mmn %%(cat %{_includedir}/httpd/.mmn 2>/dev/null || echo 0-0)}}
%{!?_httpd_confdir:    %{expand: %%global _httpd_confdir    %%{_sysconfdir}/httpd/conf.d}}
# /etc/httpd/conf.d with httpd < 2.4 and defined as /etc/httpd/conf.modules.d with httpd >= 2.4
%{!?_httpd_modconfdir: %{expand: %%global _httpd_modconfdir %%{_sysconfdir}/httpd/conf.d}}
%{!?_httpd_moddir:    %{expand: %%global _httpd_moddir    %%{_libdir}/httpd/modules}}

Name:           python3-mod_wsgi
Version:        4.7.1
Release:        3%{?dist}
Summary:        A WSGI interface for Python web applications in Apache
License:        ASL 2.0
URL:            https://modwsgi.readthedocs.io
Source0:        https://github.com/GrahamDumpleton/mod_wsgi/archive/%{version}/mod_wsgi-%{version}.tar.gz
Source1:        wsgi-python3.conf
Patch0:         mod_wsgi-4.5.20-exports.patch
# Backported upstream patch 
# https://github.com/GrahamDumpleton/mod_wsgi/commit/af3c0c2736bc0b0b01fa0f0aad3c904b7fa9c751
Patch1:         python3-mod_wsgi-4.7.1-CVE-2022-2255.patch

BuildRequires:  httpd-devel
BuildRequires:  gcc
BuildRequires:  python3-devel
BuildRequires:  python3-setuptools
BuildRequires:  python36-sphinx
BuildRequires:  python36-sphinx_rtd_theme

Requires:       httpd-mmn = %{_httpd_mmn}

Provides:       python36-mod_wsgi = %{version}-%{release}
Obsoletes:      python36-mod_wsgi < 4.6.2-3


%description
The mod_wsgi adapter is an Apache module that provides a WSGI compliant
interface for hosting Python based web applications within Apache. The
adapter is written completely in C code against the Apache C runtime and
for hosting WSGI applications within Apache has a lower overhead than using
existing WSGI adapters for mod_python or CGI.


%prep
%autosetup -n mod_wsgi-%{version} -p 1


%build
make -C docs html SPHINXBUILD=%{_bindir}/sphinx-build-%{python3_version}

export LDFLAGS="$RPM_LD_FLAGS -L%{_libdir}"
export CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
%configure --enable-shared --with-apxs=%{_httpd_apxs} --with-python=python3
%make_build

%py3_build


%install
%make_install LIBEXECDIR=%{_httpd_moddir}
mv %{buildroot}%{_httpd_moddir}/mod_wsgi{,_python3}.so

install -D -p -m 0644 %{SOURCE1} %{buildroot}%{_httpd_modconfdir}/10-wsgi-python3.conf

%py3_install
mv %{buildroot}%{_bindir}/mod_wsgi-express{,-3}


%files
%license LICENSE
%doc CREDITS.rst README.rst
%config(noreplace) %{_httpd_modconfdir}/10-wsgi-python3.conf
%{_httpd_moddir}/mod_wsgi_python3.so
%{python3_sitearch}/mod_wsgi
%{python3_sitearch}/mod_wsgi-%{version}-py%{python3_version}.egg-info
%{_bindir}/mod_wsgi-express-3


%changelog
* Wed Oct 5 2022 Diego Herrera <dherrera@redhat.com> - 4.7.1-3
- Backported fix for CVE-2022-2255

* Thu Nov 19 2020 Carl George <carl@george.computer> - 4.7.1-2
- Add provides for python36-mod_wsgi
- Add obsoletes for python36-mod_wsgi (previously packaged in third party repo)

* Sat Sep 26 2020 Carl George <carl@george.computer> - 4.7.1-1
- Initial EPEL 7 package, based on Fedora mod_wsgi package
